1 // Created on: 1992-10-02
2 // Created by: Remi GILET
3 // Copyright (c) 1992-1999 Matra Datavision
4 // Copyright (c) 1999-2014 OPEN CASCADE SAS
5 //
6 // This file is part of Open CASCADE Technology software library.
7 //
8 // This library is free software; you can redistribute it and/or modify it under
9 // the terms of the GNU Lesser General Public License version 2.1 as published
10 // by the Free Software Foundation, with special exception defined in the file
11 // OCCT_LGPL_EXCEPTION.txt. Consult the file LICENSE_LGPL_21.txt included in OCCT
12 // distribution for complete text of the license and disclaimer of any warranty.
13 //
14 // Alternatively, this file may be used under the terms of Open CASCADE
15 // commercial license or contractual agreement.
16 
17 
18 #include <ElCLib.hxx>
19 #include <GCE2d_MakeLine.hxx>
20 #include <GCE2d_MakeSegment.hxx>
21 #include <Geom2d_Line.hxx>
22 #include <Geom2d_TrimmedCurve.hxx>
23 #include <gp_Dir2d.hxx>
24 #include <gp_Lin2d.hxx>
25 #include <gp_Pnt2d.hxx>
26 #include <StdFail_NotDone.hxx>
27 
GCE2d_MakeSegment(const gp_Pnt2d & P1,const gp_Dir2d & V,const gp_Pnt2d & P2)28 GCE2d_MakeSegment::GCE2d_MakeSegment(const gp_Pnt2d& P1 ,
29 				     const gp_Dir2d& V  ,
30 				     const gp_Pnt2d& P2 )
31 {
32   gp_Lin2d Line(P1,V);
33   Standard_Real Ulast = ElCLib::Parameter(Line,P2);
34   if (Ulast != 0.0) {
35     Handle(Geom2d_Line) L = new Geom2d_Line(Line);
36     TheSegment = new Geom2d_TrimmedCurve(L,0.0,Ulast,Standard_True);
37     TheError = gce_Done;
38   }
39   else { TheError = gce_ConfusedPoints; }
40 }
41 
GCE2d_MakeSegment(const gp_Pnt2d & P1,const gp_Pnt2d & P2)42 GCE2d_MakeSegment::GCE2d_MakeSegment(const gp_Pnt2d& P1 ,
43 				     const gp_Pnt2d& P2 )
44 {
45   Standard_Real dist = P1.Distance(P2);
46   if (dist != 0.0) {
47     Handle(Geom2d_Line) L = GCE2d_MakeLine(P1,P2);
48     TheSegment = new Geom2d_TrimmedCurve(L,0.,dist,Standard_True);
49     TheError = gce_Done;
50   }
51   else { TheError = gce_ConfusedPoints; }
52 }
GCE2d_MakeSegment(const gp_Lin2d & Line,const gp_Pnt2d & Point,const Standard_Real U)53 GCE2d_MakeSegment::GCE2d_MakeSegment(const gp_Lin2d&     Line  ,
54 				     const gp_Pnt2d&     Point ,
55 				     const Standard_Real U     )
56 {
57   Standard_Real Ufirst = ElCLib::Parameter(Line,Point);
58   Handle(Geom2d_Line) L = new Geom2d_Line(Line);
59   TheSegment=new Geom2d_TrimmedCurve(L,Ufirst,U,Standard_True);
60   TheError = gce_Done;
61 }
62 
GCE2d_MakeSegment(const gp_Lin2d & Line,const gp_Pnt2d & P1,const gp_Pnt2d & P2)63 GCE2d_MakeSegment::GCE2d_MakeSegment(const gp_Lin2d& Line  ,
64 				     const gp_Pnt2d& P1    ,
65 				     const gp_Pnt2d& P2    )
66 {
67   Standard_Real Ufirst = ElCLib::Parameter(Line,P1);
68   Standard_Real Ulast = ElCLib::Parameter(Line,P2);
69   Handle(Geom2d_Line) L = new Geom2d_Line(Line);
70   TheSegment = new Geom2d_TrimmedCurve(L,Ufirst,Ulast,Standard_True);
71   TheError = gce_Done;
72 }
73 
GCE2d_MakeSegment(const gp_Lin2d & Line,const Standard_Real U1,const Standard_Real U2)74 GCE2d_MakeSegment::GCE2d_MakeSegment(const gp_Lin2d&     Line  ,
75 				     const Standard_Real U1    ,
76 				     const Standard_Real U2    )
77 {
78   Handle(Geom2d_Line) L = new Geom2d_Line(Line);
79   TheSegment = new Geom2d_TrimmedCurve(L,U1,U2,Standard_True);
80   TheError = gce_Done;
81 }
82 
Handle(Geom2d_TrimmedCurve)83 const Handle(Geom2d_TrimmedCurve)& GCE2d_MakeSegment::Value() const
84 {
85   StdFail_NotDone_Raise_if (TheError != gce_Done,
86                             "GCE2d_MakeSegment::Value() - no result");
87   return TheSegment;
88 }
89